/* dumpdflist.p
 *
 * dump a list of tables (very useful for hidden schema)
 *
 * 09/04/20     tom     created
 *
 * September, 4 2020 */

define variable dfxname as character no-undo.
define variable dfzname as character no-undo.

define variable tableList as character no-undo.

tableList = entry( 1, session:parameter, "|" ).
if tableList = "" then tableList = "ALL".

if num-entries( session:parameter, "|" ) > 1 then dfxname = entry( 2, session:parameter, "|" ).
if dfxname = "" or dfxname = ? then dfxname = ldbname(1) + ".dfx".

dfzname = replace( dfxname, "dfx", "df.noarea" ).

/* p1 = "ALL" or a comma delimited list of tables
 * p2 = output filename
 * p3 = codepage, ? = undefiend, "" = session:stream
 */

run prodict/dump_df.p ( tableList, input dfxname, "" ).

if dfxname <> dfzname then
  os-command value( substitute( 'grep -v "^  AREA " &1 > &2', dfxname, dfzname )).

quit.
