/* schemachk.p
 *
 * look for RECID and LOB fields -- they can be troublesome when dumping & loading
 * also look for tables with no indexes at all and tables with no unique index
 *
 */

define variable f as integer no-undo format ">>9".
define variable i as integer no-undo format ">>9".
define variable u as integer no-undo format ">>9".

define variable dummy as character no-undo format "x(30)" label "Index Info".

form
  f _file._file-name _field._field-name _field._data-type
 with
  frame a
  down
.

form
  _file._file-name dummy
 with
  frame b
  down
.
         
for each _file no-lock where _hidden = no:
  for each _field no-lock of _file:
    if _field._data-type = "recid" or _field._data-type matches "*LOB" then
      do:
        f = f + 1.
        display f _file._file-name _field._field-name _field._data-type with frame a.
        down with frame a.
      end.
  end.
end.

for each _file no-lock where _hidden = no:

  assign
    i = 0
    u = 0
  .

  for each _index no-lock where _index._file-recid = recid( _file ):
    if _index._unique then u = u + 1.
    if _index._index-name <> "default" then i = i + 1.
  end.

  if i = 0 then
    do:
      display _file._file-name "no indexes" @ dummy with frame b.
      down with frame b.
    end.

  if i > 0 and u = 0 then
    do:
      display _file._file-name "no unique index" @ dummy with frame b.
      down with frame b.
    end.

end.

pause.

hide frame a.

return.
